---
- name: Install node and npm
  hosts: 67.205.181.239
  tasks:
    - name: Update apt repo and cache
      ansible.builtin.apt: update_cache=yes force_apt_get=yes cache_valid_time=3600
    - name: Install nodejs and npm
      ansible.builtin.apt: 
        pkg:
          - nodejs
          - npm
      
- name: Create new linux user for node app
  hosts: 67.205.181.239
  vars_files:
    - vars.yaml
  tasks:
    - name: Create linux user
      user:
        name: "{{linux_user}}"
        comment: joey Admin
        group: admin
      register: user_creation_result # create variables from the output of an Ansible task
    - debug: msg={{user_creation_result}}


- name: Deploy nodejs app
  hosts: 67.205.181.239
  become: True
  become_user: "{{linux_user}}" #become_user= set to user with desired privileges, default is root
  vars_files:
    - vars.yaml
  tasks:
    - name: Copy nodejs folder to a server
      copy:
        src: "{{location}}/nodejs-app-{{version}}.tgz"
        #dest: /root/nodejs-app-1.0.0.tgz
        dest: "{{user_home_dir}}/"

    - name: Unpack the nodejs file
      ansible.builtin.unarchive:
        src: "{{location}}/nodejs-app-{{version}}.tgz"
        dest: "{{user_home_dir}}"
        
      register: user_creation_result
    - debug: msg={{user_creation_result}}

    - name: Install dependencies
      npm:
        #path: /root/package
        path: "{{user_home_dir}}/package"
    - name: Start the application
      #command: node /root/package/app/server
      command: node {{user_home_dir}}/package/app/server
      async: 1000 # allow nodejs server to keep running even after the playbook is done running
      poll: 0
    - name: Ensure app is running
      shell: ps aux | grep node # "command" is more secure, you can do everything with "shell"
      register: app_status
      # ansible modules normally return data, this data can be registered into a variable
    #- debug: msg={{app_status}}
    - debug: msg={{app_status.stdout_lines}}
